package com.liang.dao;

import com.liang.entity.PrjContract;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;
import java.util.Map;

/**
 * (PrjContract)表数据库访问层
 *
 * @author makejava
 * @since 2023-06-06 12:50:45
 */
public interface PrjContractDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    PrjContract queryById(Integer id);

    /**
     * 查询指定行数据
     *
     * @param prjContract 查询条件
     * @param pageable    分页对象
     * @return 对象列表
     */
    List<PrjContract> queryAllByLimit(PrjContract prjContract, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param prjContract 查询条件
     * @return 总行数
     */
    long count(PrjContract prjContract);

    /**
     * 新增数据
     *
     * @param prjContract 实例对象
     * @return 影响行数
     */
    int insert(PrjContract prjContract);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<PrjContract> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<PrjContract> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<PrjContract> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<PrjContract> entities);

    /**
     * 修改数据
     *
     * @param prjContract 实例对象
     * @return 影响行数
     */
    int update(PrjContract prjContract);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    /**
     * 批量删除合同
     *
     * @param idList
     * @return
     */
    int batchDelete(List<Integer> idList);

    /**
     * 获取合同列表
     *
     * @return
     */
    List<PrjContract> getContractList(Map map);

    int updateSpzt(PrjContract prjContract);
    /**
     * 更新审批状态
     */
    int updateSpzt(Map map);

    /**
     * 更新状态
     */
    int updateZt(Map map);

    List<PrjContract> selectByMcAndHtjr(PrjContract prjContract);
}

